searchData={"items":[{"type":"module","title":"A2S","doc":"A set of process-less functions for forming A2S challenges, requests, and parsing responses.","ref":"A2S.html"},{"type":"function","title":"A2S.challenge_request/1","doc":"","ref":"A2S.html#challenge_request/1"},{"type":"function","title":"A2S.parse_challenge/1","doc":"Parses a challenge response payload. Some game servers don't implement the challenge flow and will\nimmediately respond with the requested data. In that case `:immediate` will be returned with the data.\n\nIf the server returns data immediately, and that data is multipacket, `:multipacket` will be returned.","ref":"A2S.html#parse_challenge/1"},{"type":"function","title":"A2S.parse_multipacket_response/1","doc":"","ref":"A2S.html#parse_multipacket_response/1"},{"type":"function","title":"A2S.parse_response/1","doc":"","ref":"A2S.html#parse_response/1"},{"type":"function","title":"A2S.sign_challenge/2","doc":"","ref":"A2S.html#sign_challenge/2"},{"type":"module","title":"A2S.Client","doc":"An easy to use client that performs the handshaking and busy-work necessary to make execute A2S queries.\n\nThis client handles requests concurrently and should be suitable for most general uses.\n\nNote: must supply a :name","ref":"A2S.Client.html"},{"type":"function","title":"A2S.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"A2S.Client.html#child_spec/1"},{"type":"function","title":"A2S.Client.query/3","doc":"Query a game server running at `address` for the data specified by `query`.","ref":"A2S.Client.html#query/3"},{"type":"function","title":"A2S.Client.start_link/1","doc":"","ref":"A2S.Client.html#start_link/1"},{"type":"module","title":"A2S.Info","doc":"Struct representing an [A2S_INFO](https://developer.valvesoftware.com/wiki/Server_queries#Response_Format) response.","ref":"A2S.Info.html"},{"type":"type","title":"A2S.Info.t/0","doc":"","ref":"A2S.Info.html#t:t/0"},{"type":"module","title":"A2S.MultiPacketHeader","doc":"Struct representing a [multi-packet response header](https://developer.valvesoftware.com/wiki/Server_queries#Multi-packet_Response_Format).","ref":"A2S.MultiPacketHeader.html"},{"type":"type","title":"A2S.MultiPacketHeader.t/0","doc":"","ref":"A2S.MultiPacketHeader.html#t:t/0"},{"type":"module","title":"A2S.Player","doc":"Struct representing a player entry in an [A2S_PLAYER](https://developer.valvesoftware.com/wiki/Server_queries#Response_Format_2) response.","ref":"A2S.Player.html"},{"type":"type","title":"A2S.Player.t/0","doc":"","ref":"A2S.Player.html#t:t/0"},{"type":"module","title":"A2S.Players","doc":"Struct representing an [A2S_PLAYER](https://developer.valvesoftware.com/wiki/Server_queries#Response_Format_2) response.","ref":"A2S.Players.html"},{"type":"type","title":"A2S.Players.t/0","doc":"","ref":"A2S.Players.html#t:t/0"},{"type":"module","title":"A2S.Rule","doc":"Struct representing a rule in an [A2S_RULES](https://developer.valvesoftware.com/wiki/Server_queries#Response_Format_3) response.","ref":"A2S.Rule.html"},{"type":"type","title":"A2S.Rule.t/0","doc":"","ref":"A2S.Rule.html#t:t/0"},{"type":"module","title":"A2S.Rules","doc":"Struct representing an [A2S_RULES](https://developer.valvesoftware.com/wiki/Server_queries#Response_Format_3) response.","ref":"A2S.Rules.html"},{"type":"type","title":"A2S.Rules.t/0","doc":"","ref":"A2S.Rules.html#t:t/0"},{"type":"module","title":"A2S.DynamicSupervisor","doc":"Singleton dynamic supervisor for `A2S.Statem` processes.","ref":"A2S.DynamicSupervisor.html"},{"type":"function","title":"A2S.DynamicSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"A2S.DynamicSupervisor.html#child_spec/1"},{"type":"function","title":"A2S.DynamicSupervisor.start_child/1","doc":"Starts an `A2S.Statem` for the specified `address`.","ref":"A2S.DynamicSupervisor.html#start_child/1"},{"type":"function","title":"A2S.DynamicSupervisor.start_link/1","doc":"","ref":"A2S.DynamicSupervisor.html#start_link/1"},{"type":"module","title":"A2S.Statem","doc":"A state machine process responsible for handling all A2S queries to a game server running at the given address. Queries must be performed sequentially per address, as A2S provides no way to associate what replies associate to what responses.\n\nEach instance should exit normally after a certain interval of inactivity (currently hard-coded to 2 minutes).","ref":"A2S.Statem.html"},{"type":"function","title":"A2S.Statem.child_spec/1","doc":"","ref":"A2S.Statem.html#child_spec/1"},{"type":"function","title":"A2S.Statem.start_link/1","doc":"","ref":"A2S.Statem.html#start_link/1"},{"type":"function","title":"A2S.Statem.stop/2","doc":"","ref":"A2S.Statem.html#stop/2"},{"type":"type","title":"A2S.Statem.init_args/0","doc":"","ref":"A2S.Statem.html#t:init_args/0"},{"type":"module","title":"A2S.UDP","doc":"GenServer wrapper over `:gen_udp`, responsible for sending packets to game-servers and routing received packets to the appropriate `A2S.Statem` process.","ref":"A2S.UDP.html"},{"type":"function","title":"A2S.UDP.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"A2S.UDP.html#child_spec/1"},{"type":"function","title":"A2S.UDP.handle_call/3","doc":"Send the given `msg` packet to the game server.","ref":"A2S.UDP.html#handle_call/3"},{"type":"function","title":"A2S.UDP.handle_info/2","doc":"Forward received packets to the appropriate `A2S.Statem`.","ref":"A2S.UDP.html#handle_info/2"},{"type":"function","title":"A2S.UDP.start_link/1","doc":"","ref":"A2S.UDP.html#start_link/1"},{"type":"extras","title":"Elixir A2S","doc":"# Elixir A2S\nA library for communicating with game servers running [Valve's A2S server query protocol](https://developer.valvesoftware.com/wiki/Server_queries).","ref":"readme.html"},{"type":"extras","title":"Installation - Elixir A2S","doc":"Add `:elixir_a2s` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:elixir_a2s, \"~> 0.3.4\"}\n  ]\nend\n```\n\nDocumentation is available on [HexDocs](https://hexdocs.pm/elixir_a2s/readme.html) and may also be generated with [ExDoc](https://github.com/elixir-lang/ex_doc).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Elixir A2S","doc":"There's two general ways to use this library:\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Via `A2S.Client` - Elixir A2S","doc":"An easy to use client that should cover most use-cases. Add `A2S.Client` to your app's supervision tree:\n```elixir\nchildren = [\n  {A2S.Client, [name: MyA2SCli]}\n]\n```\nOr start the client dynamically: \n```elixir\nA2S.Client.start_link([name: MyA2SCli])\n```\n\nAfterwards querying a game server's as simple as:\n```elixir\nA2S.Client.query(:info, {{127, 0, 0, 1}, 20000}) # ipv4 address followed by port\n```\n\n#","ref":"readme.html#via-a2s-client"},{"type":"extras","title":"Via `A2S` - Elixir A2S","doc":"This module provides the means form requests, sign challenges, and parse responses for the A2S protocol. You can utilize this module directly in your application for tighter integration, but in turn you'll have to handle the networking or handshaking necessary to execute A2S queries.\n\nSee [Using A2S Directly](pages/using-a2s-directly.md) guide for further details.","ref":"readme.html#via-a2s"},{"type":"extras","title":"Configuration - Elixir A2S","doc":"The following configuration options are available for `A2S.Client`:\n\n`:name` - Required, used as the `name` of the top-level supervisor for `A2S.Client`\n\n`:port` - Port on which to open the UDP socket for communicating with game servers. Defaults to `20850`.\n\n`:idle_timeout` - Under the hood, `A2S.Client` spins up one `:gen_statem` processes per address queried. These serve two purposes - to handle all the hand-shaking and packet wrangling necessary to complete A2S queries, and to ensure queries are executed sequentially. After an address hasn't been queried for an extended period, these processes should terminate to free their memory. Defaults to `120_000` (2 minutes, expressed in milliseconds).\n\n`:recv_timeout` - Deadline to receive a response packet for each packet sent in the query sequence. Defaults to `3000` (3 seconds, expressed in milliseconds).","ref":"readme.html#configuration"},{"type":"extras","title":"Unsupported Games/Features - Elixir A2S","doc":"The features and game servers listed below are unsupported due to disuse and to favor maintainability.\n\n#### [Source 2006](https://en.wikipedia.org/wiki/Source_(game_engine)#Source_2006) / \"Pre-Orange Box\" servers\nWould require supporting compression in multipacket responses. Not only adds code complexity, but would require users to have bzip2 installed.\n\n##","ref":"readme.html#unsupported-games-features"},{"type":"extras","title":"Other game servers utilizing multi-packet compression - Elixir A2S","doc":"(see above)\n\n##","ref":"readme.html#other-game-servers-utilizing-multi-packet-compression"},{"type":"extras","title":"GoldSrc Servers not using the standard protocol - Elixir A2S","doc":"Should impact exceedingly few applications as many GoldSrc servers use the current standard anyway.\n\n#### [The Ship](https://steamcharts.com/app/2400)\nUses proprietary fields only worth supporting out of posterity-sake.\n\n#### [A2A_PING](https://developer.valvesoftware.com/wiki/Server_queries#A2A_PING)\nConsidered deprecated by Valve and is unsupported by many if not almost all most engines.\n\n#### [A2S_SERVERQUERY_GETCHALLENGE](https://developer.valvesoftware.com/wiki/Server_queries#A2S_SERVERQUERY_GETCHALLENGE)\nOnly used by a handful of niche games. Normal challenge flow should work anyway.","ref":"readme.html#goldsrc-servers-not-using-the-standard-protocol"},{"type":"extras","title":"Debugging - Elixir A2S","doc":"`A2S.Client` uses Erlang's [gen_statem](https://www.erlang.org/doc/man/gen_statem.html) behavior to function and therefore requires the following `Logger` configuration to report exceptions and crashes:\n\n```elixir\nconfig :logger,\n  handle_otp_reports: true,\n  handle_sasl_reports: true\n```\nor in a REPL:\n```elixir\nLogger.configure(handle_otp_reports: true)\nLogger.configure(handle_sasl_reports: true)\n```","ref":"readme.html#debugging"},{"type":"extras","title":"Using A2S Directly","doc":"# Using `A2S` Directly\n\nIf `A2S.Client`'s process architecture isn't suitable for your needs, you can use the parsing functions in `A2S` directly. In order to do so, you'll need to understand the steps necessary to perform A2S queries.","ref":"using-a2s-directly.html"},{"type":"extras","title":"A rough visual guide - Using A2S Directly","doc":"Each colored box is some internal action taken by your app. Each arrow represents a game server reply.\n\n#","ref":"using-a2s-directly.html#a-rough-visual-guide"},{"type":"extras","title":"In a perfect world this would be the flow: - Using A2S Directly","doc":"*Where the 'challenge step' is necessary to mitigate A2S queries from being used in reflection attacks.*\n![In a perfect world](assets/in-a-perfect-world.svg)\n\n#","ref":"using-a2s-directly.html#in-a-perfect-world-this-would-be-the-flow"},{"type":"extras","title":"How it actually works: - Using A2S Directly","doc":"*Given the A2S protocol's used by a tons of games in various states of implementation.* ([fullscreen](assets/how-it-actually-works.svg))\n![How it actually works](assets/how-it-actually-works.svg)\n\n`A2S.Statem` may be of good reference for how to handle this in your own app.","ref":"using-a2s-directly.html#how-it-actually-works"},{"type":"extras","title":"Other notes - Using A2S Directly","doc":"- `A2S.Client` is specifically optimized for querying numerous game servers on a frequent basis.\n- Official Valve servers may not respond to A2S queries.\n- Some game servers ignore certain fields, filling them with zero values.\n- [A2S_INFO](https://steamcommunity.com/discussions/forum/14/2974028351344359625/) was updated relatively recently to the rest of the protocol to mitigate reflection attacks.\n- See Valve's [official A2S documentation](https://developer.valvesoftware.com/wiki/Server_queries) for more details on A2S.","ref":"using-a2s-directly.html#other-notes"}],"content_type":"text/markdown"}